/*
 * MainSim.java
 *
 * Created on February 8, 2004, 11:18 PM
 */

package MySimulation;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.*;
import java.util.*;


/*
 * Flocking Simulation program
 * independent study project for University of Marylnad College Park
 * Computer Science Department
 *
 * by Tzu-hsiu Chiou
 *Supervised by Dr. David Mount
 * 
 * final version:  5/28/04
 * This program simulate a group of entites (which will be refered as "boid") move in an obstacle environement
 *
 * The frame work is taken from code attached with Java for Dummy book.  The interfaced has been ported for NetBean, and.
 * @author  Kevin Chiou
 * the original frame work by   @author <A HREF="mailto:anatoly@isc.com"> Anatoly Goroshnik</A>
 */






public class MainSim extends javax.swing.JApplet implements Runnable {
    
    final int PAUSE_LENGTH = 2; // millisecs to pause between ticks
    final boolean SHOW_TRAIL = false; // do sprites show trail?
    
    int heading = 0; //
    
    //variables for double-buffered painting...
    Image offScreenImage = null;
    Graphics offScreenGraphics = null;
    Dimension offScreenSize = null;
    
    TextField mfRatField = new TextField(" " + Creature.MFRAT + " ");
    TextField bRatField = new TextField(" " + Creature.BIRTH_RATE + " ");
    RectBackground rectbg = new RectBackground();   
      
    //array of color choices
    String stringColors[] = {"red", "green", "blue", "yellow", "black"};
    Color colorColors[] = {Color.red, Color.green, Color.blue, Color.yellow, Color.black};   
    
    
    Vector creatureList = new Vector(); //a dynamic array of creatures
    Vector sysEventList = new Vector(); //a dynamic array of future events
    
    Thread mainThread; //main thread
    int males = 0;
    int females = 0;
    boolean isRunning = false;

    int mode = 0;
    int num = 1;
    
    /** Initializes the applet MainSim */
    public void init() {       
         
        initComponents(); // initialize NetBean componenets.        
        ecoSystem.repaint(); // repaint the window
        Creature.sysEventList = sysEventList;
        Dimension dim = ecoSystem.getSize();
        
        // set up back ground
        rectbg.generateRoadMap(100, (int) dim.getWidth(), (int) dim.getHeight()); //gnereate a road map
        // turn drawings off
        rectbg.DrawNodes = false;
        rectbg.DrawEdges= false;      
                  
        startStop();  // strat the thread                                                        
    }
    
    // !!!!!!!!! some warning about NetBeans, apperantly there are some error associated with GUI generation code, 
    // the ActionCommand for RadioButton might not be generated correctly !!!! 
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        creatureColor = new javax.swing.ButtonGroup();
        creatureSize = new javax.swing.ButtonGroup();
        ecoSystem = new javax.swing.JPanel();
        controlPanel = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jCheckBox1 = new javax.swing.JCheckBox();
        jButton2 = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jRadioButton4 = new javax.swing.JRadioButton();
        jRadioButton3 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton5 = new javax.swing.JRadioButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jRadioButton6 = new javax.swing.JRadioButton();
        jRadioButton7 = new javax.swing.JRadioButton();
        jRadioButton8 = new javax.swing.JRadioButton();
        jRadioButton9 = new javax.swing.JRadioButton();
        jRadioButton10 = new javax.swing.JRadioButton();
        jTextArea1 = new javax.swing.JTextArea();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jButton4 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        txtNumNodes = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();

        getContentPane().setLayout(null);

        setBackground(new java.awt.Color(204, 204, 204));
        ecoSystem.setBackground(java.awt.Color.white);
        ecoSystem.setForeground(new java.awt.Color(204, 204, 204));
        ecoSystem.setMinimumSize(new java.awt.Dimension(640, 480));
        ecoSystem.setPreferredSize(new java.awt.Dimension(640, 480));
        ecoSystem.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ecoSystemMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                ecoSystemMousePressed(evt);
            }
        });
        ecoSystem.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                ecoSystemMouseMoved(evt);
            }
        });

        getContentPane().add(ecoSystem);
        ecoSystem.setBounds(10, 10, 790, 700);

        controlPanel.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED, java.awt.Color.darkGray, java.awt.Color.black, null, null));
        controlPanel.setForeground(new java.awt.Color(204, 204, 204));
        controlPanel.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                controlPanelMouseMoved(evt);
            }
        });

        jButton1.setText("Start/Stop");
        jButton1.setToolTipText("run or pause the simulation");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        controlPanel.add(jButton1);

        jCheckBox1.setSelected(true);
        jCheckBox1.setText("ChasingMouse");
        jCheckBox1.setToolTipText("Make the objects to chase the mouse");
        controlPanel.add(jCheckBox1);

        jButton2.setText("CLEAR");
        jButton2.setToolTipText("Remove all moving objects");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        controlPanel.add(jButton2);

        jPanel3.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabel5.setFont(new java.awt.Font("Dialog", 1, 14));
        jLabel5.setText("Boid property:");
        jPanel3.add(jLabel5);

        jPanel1.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED, null, java.awt.Color.black, null, null));
        jPanel1.setToolTipText("Change the colord of the boids");
        jLabel1.setText("Color:");
        jPanel1.add(jLabel1);

        jRadioButton4.setSelected(true);
        jRadioButton4.setText("red");
        creatureColor.add(jRadioButton4);
        jRadioButton4.setActionCommand("0");
        jRadioButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton4ActionPerformed(evt);
            }
        });

        jPanel1.add(jRadioButton4);

        jRadioButton3.setText("green");
        creatureColor.add(jRadioButton3);
        jRadioButton3.setActionCommand("1");
        jPanel1.add(jRadioButton3);

        jRadioButton2.setText("blue");
        creatureColor.add(jRadioButton2);
        jRadioButton2.setActionCommand("2");
        jPanel1.add(jRadioButton2);

        jRadioButton1.setText("yellow");
        creatureColor.add(jRadioButton1);
        jRadioButton1.setActionCommand("3");
        jPanel1.add(jRadioButton1);

        jRadioButton5.setText("black");
        creatureColor.add(jRadioButton5);
        jRadioButton5.setActionCommand("4");
        jPanel1.add(jRadioButton5);

        jPanel3.add(jPanel1);

        jPanel2.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED, null, java.awt.Color.black, null, null));
        jPanel2.setToolTipText("Change the size of the boid");
        jLabel2.setText("Size:");
        jPanel2.add(jLabel2);

        jRadioButton6.setSelected(true);
        jRadioButton6.setText("1");
        creatureSize.add(jRadioButton6);
        jRadioButton6.setActionCommand("1");
        jPanel2.add(jRadioButton6);

        jRadioButton7.setText("2");
        creatureSize.add(jRadioButton7);
        jRadioButton7.setActionCommand("2");
        jPanel2.add(jRadioButton7);

        jRadioButton8.setText("3");
        creatureSize.add(jRadioButton8);
        jRadioButton8.setActionCommand("3");
        jPanel2.add(jRadioButton8);

        jRadioButton9.setText("4");
        creatureSize.add(jRadioButton9);
        jRadioButton9.setActionCommand("4");
        jPanel2.add(jRadioButton9);

        jRadioButton10.setText("5");
        creatureSize.add(jRadioButton10);
        jRadioButton10.setActionCommand("5");
        jRadioButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton10ActionPerformed(evt);
            }
        });

        jPanel2.add(jRadioButton10);

        jPanel3.add(jPanel2);

        controlPanel.add(jPanel3);

        controlPanel.add(jTextArea1);

        controlPanel.add(jPanel4);

        jPanel5.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabel4.setFont(new java.awt.Font("Dialog", 1, 14));
        jLabel4.setText("Road map property:");
        jPanel5.add(jLabel4);

        jButton4.setText("ShowRoadmap");
        jButton4.setToolTipText("Display or hide road map");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jPanel5.add(jButton4);

        jLabel3.setText("number of nodes for Roadmap:");
        jPanel5.add(jLabel3);

        txtNumNodes.setText("100");
        txtNumNodes.setPreferredSize(new java.awt.Dimension(60, 20));
        jPanel5.add(txtNumNodes);

        jButton3.setText("GenerateRoadMap");
        jButton3.setToolTipText("Generate a new road map");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jPanel5.add(jButton3);

        controlPanel.add(jPanel5);

        jLabel6.setFont(new java.awt.Font("Dialog", 1, 10));
        jLabel6.setText("Program by Kevin Chiou forUMCP independent study project supervised by Dr. David Mount");
        controlPanel.add(jLabel6);

        jLabel7.setFont(new java.awt.Font("Dialog", 1, 10));
        jLabel7.setText("Program frame work use code by Anatoly Goroshnik from Java Programming for Dummies");
        controlPanel.add(jLabel7);

        getContentPane().add(controlPanel);
        controlPanel.setBounds(0, 720, 780, 190);

    }//GEN-END:initComponents
    
    private void jRadioButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton4ActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_jRadioButton4ActionPerformed
    
    private void jRadioButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton10ActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_jRadioButton10ActionPerformed
    
    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
      
        if (rectbg.DrawNodes == true)
        {rectbg.DrawNodes = false;
         rectbg.DrawEdges= false;
        }
        else {
            rectbg.DrawNodes = true;
            rectbg.DrawEdges = true;
        }
    }//GEN-LAST:event_jButton4ActionPerformed
    
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // Add your handling code here:
        try{
            int num = Integer.parseInt( txtNumNodes.getText() );
            if (num > 0) {
                startStop();
                rectbg.clearRoadMap();
                Dimension dim = ecoSystem.getSize();                
                rectbg.generateRoadMap(num, (int) dim.getWidth(), (int) dim.getHeight());             
                startStop();
            }
            
        }
        catch(NumberFormatException e){}
    }//GEN-LAST:event_jButton3ActionPerformed
    
    private void ecoSystemMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ecoSystemMouseMoved
        // Add your handling code here:
        if (jCheckBox1.isSelected()) {
            for (Enumeration e = creatureList.elements(); e.hasMoreElements() ;) {
                //let creature know that clock had ticked
                ((Creature)(e.nextElement())).set_seeking(evt.getX(), evt.getY());            }
            
            rectbg.calculatePath(rectbg.findClosestNode(evt.getX(), evt.getY()));
        }
        else {
            for (Enumeration e = creatureList.elements(); e.hasMoreElements() ;) {
                //let creature know that clock had ticked
                ((Creature)(e.nextElement())).disable_seeking();            }
        }
        /* -------- code for drawing vectors, taken out
        if (jCheckBox2.isSelected())
        {
             for (Enumeration e = creatureList.elements(); e.hasMoreElements() ;) {
                //let creature know that clock had ticked
                ((Creature)(e.nextElement())).setdrawextra();            }
        }
        else
        {
             for (Enumeration e = creatureList.elements(); e.hasMoreElements() ;) {
                //let creature know that clock had ticked
                ((Creature)(e.nextElement())).cleardrawextra();            }
        }
         */
        
    }//GEN-LAST:event_ecoSystemMouseMoved
    
    private void ecoSystemMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ecoSystemMousePressed

    }//GEN-LAST:event_ecoSystemMousePressed
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // Add your handling code here:
        removeCreatures(creatureList.size());
    }//GEN-LAST:event_jButton2ActionPerformed
    
    private void controlPanelMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_controlPanelMouseMoved
        // Add your handling code here:
        
    }//GEN-LAST:event_controlPanelMouseMoved
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Add your handling code here:
        startStop();
    }//GEN-LAST:event_jButton1ActionPerformed
    
    private void ecoSystemMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ecoSystemMouseClicked
        // Add your handling code here:
        if (evt.getButton() == evt.BUTTON3) {
            /*    for (Enumeration e = creatureList.elements(); e.hasMoreElements() ;) {
                //let creature know that clock had ticked
                ((Creature)(e.nextElement())).set_seeking(evt.getX(), evt.getY());            }
             */
        }
        if (evt.getButton() == evt.BUTTON1 ){
            if (!rectbg.checkcontains(evt.getX(), evt.getY())) {
                int size = Integer.parseInt(creatureSize.getSelection().getActionCommand(), 10);
                int mycolor = Integer.parseInt(creatureColor.getSelection().getActionCommand(), 10);
                Color col = colorColors[mycolor];             
                
                
                sysEventList.addElement(new sysEvent(sysEvent.GIVE_BIRTH,
                new Creature(ecoSystem, size, col, evt.getX(), evt.getY(), rectbg)));
                
                handleSysEvents();
                update(ecoSystem.getGraphics()); //update screen
            }
        }
        if (evt.getButton() == evt.BUTTON3) {
            //  bk.collides(evt.getX(), evt.getY());
            System.out.println("coordinate: (" + evt.getX() + "," + evt.getY() + ")");
        }
        
    }//GEN-LAST:event_ecoSystemMouseClicked
    
    
    public void run() {        
        //   startStop();        
                
        // int i;        
        while (true) {
            
            handleSysEvents(); //process all events        
            
        
            for (Enumeration i = creatureList.elements(); i.hasMoreElements() ;){
                
            
                Creature tempi = (Creature) i.nextElement();                                            
                for (Enumeration j = creatureList.elements(); j.hasMoreElements() ;){
                    Creature tempj = (Creature) j.nextElement();
                    if (tempi != tempj) {
                        //checkCollision((Creature) creatureList.elementAt(i),
                        //(Creature) creatureList.elementAt(j));
                        
                        
                        
                        //Creature c1 = (Creature) creatureList.elementAt(i);
                        //Creature c2 = (Creature) creatureList.elementAt(j);
                        Creature c1 = tempi;
                        Creature c2 = tempj;
                        
                        if (c1.getColor().equals(c2.getColor())) {
                            c1.add_neighbor(c2);
                        }
                        else c1.add_enemy(c2);
                        
                    }
                }
                tempi.tick();
                
                //if (rectbg.checkcontains(tempi.getX(), tempi.getY())) 
                {
                    //tempi.reversetick();                    
                    
                     
                    // following if statement implement the bounce behavior
                    if (rectbg.checkcontains(tempi.getX()+3, tempi.getY()+3))
                    {
                            tempi.reversetick();   
                        tempi.bounceVertical();
                        tempi.bounceHorizontal();
                     
                    }
                    else if (rectbg.checkcontains(tempi.getX()+3, tempi.getY()-3))
                    {                     
                            tempi.reversetick();   
                        tempi.bounceVertical();
                        tempi.bounceHorizontal();                     
                    }
                    else if (rectbg.checkcontains(tempi.getX()-3, tempi.getY()-3))
                    {                     
                            tempi.reversetick();   
                        tempi.bounceVertical();
                        tempi.bounceHorizontal();                     
                    }
                    else if (rectbg.checkcontains(tempi.getX()-3, tempi.getY()+3))
                    {                     
                            tempi.reversetick();   
                        tempi.bounceVertical();
                        tempi.bounceHorizontal();                     
                   }
                    else
                    {
                    if (rectbg.checkcontains(tempi.getX()-1, tempi.getY()))
                    {         
                         tempi.reversetick();   
                        tempi.bounceVertical();   
                        
                    }
                    if (rectbg.checkcontains(tempi.getX()+1, tempi.getY()))
                    {
                         tempi.reversetick();   
                        tempi.bounceVertical();                                                             
                    }
                     
                    if (rectbg.checkcontains(tempi.getX(), tempi.getY()-1))
                    {                        
                         tempi.reversetick();   
                        tempi.bounceHorizontal();                                                                     
                    }
                    else if (rectbg.checkcontains(tempi.getX(), tempi.getY()+1))
                    {
                         tempi.reversetick();   
                        tempi.bounceHorizontal();                                                                     
                    }
                    }
                    /*
                    if (rectbg.checkcontains(tempi.getX()+3, tempi.getY()+3))
                    {
                        tempi.bounceVertical();
                        tempi.bounceHorizontal();
                     
                    }
                    else if (rectbg.checkcontains(tempi.getX()+3, tempi.getY()-3))
                    {                     
                        tempi.bounceVertical();
                        tempi.bounceHorizontal();                     
                    }
                    else if (rectbg.checkcontains(tempi.getX()-3, tempi.getY()-3))
                    {                     
                        tempi.bounceVertical();
                        tempi.bounceHorizontal();                     
                    }
                    else if (rectbg.checkcontains(tempi.getX()-3, tempi.getY()+3))
                    {                     
                        tempi.bounceVertical();
                        tempi.bounceHorizontal();                     
                   }                                                                           
                    */
                    // set sx and synchronized to -1 will force research for path
                    tempi.sx = -1;
                    tempi.sy = -1;
                    
                }
                
                
            }
         
            
            
            update(ecoSystem.getGraphics()); //update screen
            
            
            try {
                Thread.sleep(PAUSE_LENGTH); //wait for the next clock tick
            } catch (InterruptedException e) {}
            
            
        }}
    
    public void stop() {
        if (mainThread != null) {
            mainThread.stop();
            isRunning = false;
            mainThread = null;
        }
    }
    
    public final void update(Graphics g){
        //implements no-flicker graphis using double buffering
        Dimension dim = ecoSystem.getSize();
        
        if((offScreenImage == null) || (dim.width != offScreenSize.width) ||
        (dim.height != offScreenSize.height)){
            offScreenImage = createImage(dim.width, dim.height);
            offScreenSize = dim;
            offScreenGraphics = offScreenImage.getGraphics();
            if (SHOW_TRAIL)
                offScreenGraphics.clearRect(0, 0, offScreenSize.width, offScreenSize.height);
        }
        if (!SHOW_TRAIL)
            offScreenGraphics.clearRect(0, 0, offScreenSize.width, offScreenSize.height);
        
        
        // bk.paint(offScreenGraphics);
        //paint(offScreenGraphics);
        // g.drawRect(0, 0,(int) dim.getWidth()-1, (int)dim.getHeight()-1);
        rectbg.paint(offScreenGraphics);
        paint(offScreenGraphics);
        
        //g.drawImage(offScreenImage, 0, 0, null);
        
        controlPanel.repaint();
        ecoSystem.getGraphics().drawImage(offScreenImage, 0, 0, null);
        
    }
    
    public void paint(Graphics g) {
        // draw background
        g.setColor(Color.BLACK);
        Dimension dim = ecoSystem.getSize();
        g.drawRect(0, 0,(int) dim.getWidth()-1, (int)dim.getHeight()-1);
        
        
        
        //Rectangle temp = g.getClipBounds();
        //g.drawRect((int) temp.getCenterX(), (int) temp.getCenterY(), (int) temp.getWidth(), (int) temp.getHeight());
        
        //ask creature to paint itself on screen
        for (Enumeration e = creatureList.elements(); e.hasMoreElements() ;)
            ((Creature)(e.nextElement())).paint(g);
        /*
        showStatus("Number of creatures: "+(males+females)+
        "  Males: "+males+"  Females: "+females+
        "  Status: "+(isRunning?"running":"stopped"));
         */
        showStatus("Number of creatures: "+(males+females)+
        "  Status: "+(isRunning?"running":"stopped"));
        
    }
    /*
    public void actionPerformed(ActionEvent e) {
        String arg = e.getActionCommand();
     
        if ("START / STOP".equals(arg))
            startStop();
        else if ("add".equals(arg))
            addCreatures(Integer.parseInt(addChoice.getSelectedItem()));
        else if ("remove".equals(arg))
            removeCreatures(Integer.parseInt(removeChoice.getSelectedItem()));
    }
     */
    
    void handleSysEvents() {
        // handle ecoSystem events
        sysEvent evt = null;
        
        for (Enumeration e = sysEventList.elements(); e.hasMoreElements() ;) {
            evt = (sysEvent) e.nextElement();
            switch (evt.action) {
                case sysEvent.KILL:
                    //remove creature from the list
                    creatureList.removeElement(evt.subject);
                    if (evt.subject.gender == Creature.MALE)
                        males--;
                    else
                        females--;
                    break;
                case sysEvent.GIVE_BIRTH:
                    //add creature to the list
                    creatureList.addElement(evt.subject);
                    if (evt.subject.gender == Creature.MALE)
                        males++;
                    else
                        females++;
                    break;
                case sysEvent.GROW:
                    //increase creature size
                    evt.subject.grow();
                    break;
                case sysEvent.BOUNCE:
                    //bounce creatures off each other
                    bounce(evt.subject, evt.subject2);
                    break;
                case sysEvent.EAT:
                    //satisfy the hunger
                    evt.subject.eat(evt.subject2);
                    break;
                    /* handle new actions here */
            }
        }
        sysEventList.removeAllElements();
    }
    
    void addCreatures(int num) {
        //populate our ecoSystem
        for (int i = 0; i < num; i++) {
            sysEventList.addElement(new sysEvent(sysEvent.GIVE_BIRTH,
            new Creature(ecoSystem, (int) (Math.random() * (Creature.MAXSIZE - 1) + 1),
            new Color((int)(Math.random() * 255), (int) (Math.random() * 255),
            (int) (Math.random() * 255)), (int) (Math.random() * ecoSystem.getSize().getWidth()),
            (int) (Math.random() * ecoSystem.getSize().getHeight()), rectbg) ));
        }
        handleSysEvents();
        update(ecoSystem.getGraphics()); //update screen
    }
    
    void removeCreatures(int num) {
        for (int i = 0; i < num; i++)
            if (creatureList.size() > 0) {
                sysEventList.addElement(new sysEvent(sysEvent.KILL,
                (Creature) creatureList.elementAt((int)(Math.random()*creatureList.size()))));
                handleSysEvents();
            }
        update(ecoSystem.getGraphics()); //update screen
    }
    
    void startStop() {
        if (isRunning) {
            isRunning = false;
            mainThread.stop();
            mfRatField.setEditable(true);
            bRatField.setEditable(true);
            mainThread = null;
        }
        else {
            Creature.MFRAT = (new Double(mfRatField.getText())).doubleValue();
            Creature.BIRTH_RATE = (new Double(bRatField.getText())).doubleValue();
            mfRatField.setEditable(false);
            bRatField.setEditable(false);
            mainThread = new Thread(this);
            mainThread.start();
            isRunning = true;
        }
        update(ecoSystem.getGraphics()); //update screen
    }
    
    void checkCollision(Creature firstCreature, Creature secondCreature) {
        double  d = dist(secondCreature.positionX, firstCreature.positionX,
        secondCreature.positionY, firstCreature.positionY);
        boolean allIsWell = true;
        /*
        if (d <= (secondCreature.radius + firstCreature.radius)) {
            if (secondCreature.getColor().equals(firstCreature.getColor())) // same group
            {
            }
         
            if (secondCreature.size == firstCreature.size)
                sysEventList.addElement(new sysEvent(sysEvent.BOUNCE, firstCreature, secondCreature));
            else { //is anybody hungry?
                if (secondCreature.size > firstCreature.size) { //secondCreature wins
                    if (secondCreature.isHungry()) {
                        sysEventList.addElement(new sysEvent(sysEvent.EAT, secondCreature, firstCreature));
                        allIsWell = false;
                    }
                    else
                        sysEventList.addElement(new sysEvent(sysEvent.BOUNCE, firstCreature, secondCreature));
                }
                else { //firstCreature wins
                    if (firstCreature.isHungry()) {
                        sysEventList.addElement(new sysEvent(sysEvent.EAT, firstCreature, secondCreature));
                        allIsWell = false;
                    }
                    else
                        sysEventList.addElement(new sysEvent(sysEvent.BOUNCE, firstCreature, secondCreature));
                }
            }
            //give birth?
            if ((secondCreature.gender != firstCreature.gender) &&
            (Math.random() < Creature.BIRTH_RATE) &&
            (secondCreature.isAdult()) && (firstCreature.isAdult()) && allIsWell) {
                Color col = new Color((int)((secondCreature.color.getRed() + firstCreature.color.getRed()) / 2),
                (int)((secondCreature.color.getGreen() + firstCreature.color.getGreen()) / 2),
                (int)((secondCreature.color.getBlue() + firstCreature.color.getBlue()) / 2));
                sysEventList.addElement(new sysEvent(sysEvent.GIVE_BIRTH,
                new Creature(ecoSystem, 1, col,
                (int)(secondCreature.positionX + secondCreature.radius),
                (int)(secondCreature.positionY + secondCreature.radius))));
         
                secondCreature.justGaveBirth();
                firstCreature.justGaveBirth();
            }
        }
         */
    }
    
    
    
    void bounce(Creature firstCreature, Creature secondCreature) {
        double massFirst   = firstCreature.radius * firstCreature.radius;
        double massSecond  = secondCreature.radius * secondCreature.radius;
        double speedFirst  = (2 * massSecond * secondCreature.speed + (massFirst - massSecond) *
        firstCreature.speed) / (massSecond + massFirst);
        double speedSecond = (2 * massFirst * firstCreature.speed + (massSecond - massFirst) *
        secondCreature.speed) / (massSecond + massFirst);
        int combDir        = (secondCreature.direction + firstCreature.direction) / 2;
        double dist        = dist(secondCreature.positionX, firstCreature.positionX,
        secondCreature.positionY, firstCreature.positionY);
        
        firstCreature.setSpeed(speedFirst);
        secondCreature.setSpeed(speedSecond);
        firstCreature.heading((combDir - (firstCreature.direction - combDir)) % 360);
        secondCreature.heading((combDir - (secondCreature.direction - combDir)) % 360);
        
        //remove firstCreature from zone of interference with secondCreature
        firstCreature.positionX = (float)(secondCreature.positionX +
        ((secondCreature.radius + firstCreature.radius) *
        (firstCreature.positionX - secondCreature.positionX) / dist));
        firstCreature.positionY = (float)(secondCreature.positionY +
        ((secondCreature.radius + firstCreature.radius) *
        (firstCreature.positionY - secondCreature.positionY) / dist));
    }
    
    double dist(float x1, float x2, float y1, float y2) {
        return Math.sqrt((x1 - x2)*(x1 - x2) + (y1 - y2)*(y1 - y2));
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel controlPanel;
    private javax.swing.ButtonGroup creatureColor;
    private javax.swing.ButtonGroup creatureSize;
    private javax.swing.JPanel ecoSystem;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton10;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton3;
    private javax.swing.JRadioButton jRadioButton4;
    private javax.swing.JRadioButton jRadioButton5;
    private javax.swing.JRadioButton jRadioButton6;
    private javax.swing.JRadioButton jRadioButton7;
    private javax.swing.JRadioButton jRadioButton8;
    private javax.swing.JRadioButton jRadioButton9;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField txtNumNodes;
    // End of variables declaration//GEN-END:variables
    
}
