/*
 * RectBackground.java
 *
 * Created on April 4, 2004, 7:46 PM
 */

package MySimulation;

/**
 *
 * @author  Kevin Chiou
 */
import java.awt.geom.*;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.regex.*;
import java.util.Vector;
import java.util.Enumeration;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.*;







public class RectBackground {
    Vector rects = new Vector(); // a vector storing all rectangles
    final static double blurfactor = 20; // blurs used to calculate line intersection
    final static int MinDistance =20;  // minimal distance any 2 points can be
    final static int MaxPathDistance = 100;  // minimal distance any 2 points can be
    final static int NumberOfSector = 6; // use to limit number of edges per sector
    
    
    Vector nodes = new Vector(); // nodes to track roadmaps
    boolean edges[][];
    boolean DrawNodes = true;
    boolean DrawEdges = true;
    
    MyGraph graph;
    
    /** Creates a new instance of RectBackground */
    String mycommand[] =
        {
    "; double x, double y, double w, double h, color c",
"; don't leave any blank space in between",
"; 0 an downward opening",
" 100, 100, 20, 50, 200",
" 120, 100, 60, 10, 200 ",
" 180, 100, 20, 50, 200",
"; 3 an right opening",
" 300, 400, 40, 10, 200",
" 300, 410, 10, 50, 200 ",
" 300, 460, 40, 10, 200",
"; 6 an left opening",
" 200, 400, 40, 10, 200",
" 230, 410, 10, 50, 200 ",
" 200, 460, 40, 10, 200",
"; 9 an up opening",
" 500, 400, 10, 50, 200",
" 510, 440, 60, 10, 200 ",
" 570, 400, 10, 50, 200",
"; 12 an downward opening",
" 540, 200, 20, 50, 200",
" 560, 200, 60, 10, 200 ",
" 620, 200, 20, 50, 200",
"; 15 an right opening",
" 400, 100, 40, 10, 200",
" 400, 110, 10, 50, 200 ",
" 400, 160, 40, 10, 200",
"; 18 an left opening",
" 300, 500, 40, 10, 200",
" 340, 510, 10, 50, 200 ",
" 350, 560, 40, 10, 200",
"; 21 an up opening",
" 300, 100, 10, 50, 200",
" 310, 130, 60, 10, 200 ",
" 370, 100, 10, 50, 200",
"; 24, an right opening",
" 400, 200, 40, 10, 200",
" 400, 210, 10, 50, 200 ",
" 400, 260, 40, 10, 200",
"; 27, an left opening",
" 600, 600, 40, 10, 200",
" 640, 610, 10, 50, 200 ",
" 650, 660, 40, 10, 200",
"; 30 an up opening",
" 600, 300, 10, 50, 200",
" 610, 330, 60, 10, 200",
" 670, 300, 10, 50, 200",
"; 33",
" 400, 300, 20, 100, 200",
" 100, 300, 20, 230, 200",
";36 end of file"
        };
        
    public RectBackground() {
        int num = 0;
        
         while(num < mycommand.length) {
                String command = mycommand[num];
                if (! (command.charAt(0) == ';' ) && ! (command.length() < 5))
                {                             
                double x, y, width, height;
                int color;
                String parameters[] = ExtractParameter(command);
                if (parameters.length != 5) return;
                x = Double.parseDouble(parameters[0]);
                y = Double.parseDouble(parameters[1]);
                width = Double.parseDouble(parameters[2]);
                height = Double.parseDouble(parameters[3]);
                color = Integer.parseInt(parameters[4]);
                System.out.println(x +  ", " + y +  ", " + width +  ", " +  height + ", " + color);
                
                Rectangle2D newrect = new Rectangle2D.Double(x,y,width, height) ;
                rects.add(newrect);
                }
                num++;
            }
        
        /*
        File awkfile = null;
        FileInputStream awk = null;
        FileReader blah = null;
        BufferedReader infile = null;
        String command = new String();
        
        try{
            //String filename = new String("c:\\myjava\\mysimulation\\rectinfo.txt");
           String filename = new String("rectinfo.txt");
           
           awkfile = new File( filename);
           
            System.out.println(awkfile.getAbsolutePath() );
            if (!awkfile.exists()) throw new IOException("file doesn't exist");
            awk = new FileInputStream(awkfile);
            blah = new FileReader(awkfile);
            infile = new BufferedReader(blah);
            command = infile.readLine();
            
            while(command != null) {
                if (! (command.charAt(0) == ';' ) && ! (command.length() < 5))
                {                             
                double x, y, width, height;
                int color;
                String parameters[] = ExtractParameter(command);
                if (parameters.length != 5) throw new IOException("wrong number of parameters");
                x = Double.parseDouble(parameters[0]);
                y = Double.parseDouble(parameters[1]);
                width = Double.parseDouble(parameters[2]);
                height = Double.parseDouble(parameters[3]);
                color = Integer.parseInt(parameters[4]);
                System.out.println(x +  ", " + y +  ", " + width +  ", " +  height + ", " + color);
                
                Rectangle2D newrect = new Rectangle2D.Double(x,y,width, height) ;
                rects.add(newrect);
                }
                command = infile.readLine();
            }
        }
        
           catch(IOException e) {
                    System.out.println("Exception: file read error occured");
                    System.out.println(e.toString());
                    System.exit(1);
            }
         */

    }
    
    public void paint(Graphics g) {
        int i = 0;
        g.setColor(Color.BLACK);
          for(Enumeration e = rects.elements(); e.hasMoreElements();) {
            Rectangle2D rect = (Rectangle2D) e.nextElement();            
           g.drawRect((int) rect.getX(), (int)rect.getY(), (int)rect.getWidth(), (int)rect.getHeight());
           //g.drawRect((int) rect.getX(), (int)rect.getY(), (int)rect.getWidth(), (int)rect.getHeight());
            //g.drawString( Integer.toString(i) , (int) (rect.getX() + (rect.getWidth() / 2 - 7)), (int) (rect.getY() + (rect.getHeight() / 2 + 7)));
            i++;
        }
        // draw nodes for roadmap
        if (DrawNodes)
        {
         i = 0;
         for(Enumeration e = nodes.elements(); e.hasMoreElements();) {
             int diameter = 20;
             int radius = diameter / 2;
            Point2D pt = (Point2D) e.nextElement();
            g.drawArc((int) pt.getX() - radius, (int)pt.getY() - radius, (int)diameter, (int)diameter, 0, 360);
            //g.drawRect((int) rect.getX(), (int)rect.getY(), (int)rect.getWidth(), (int)rect.getHeight());
            String message = new String();
           message = Integer.toString(i) + ", d= " + graph.getDistance(i);
           
            g.drawString( message , (int) pt.getX(), (int) pt.getY()  );
            i++;
        }
        }
        
        if (DrawEdges)
        {
        int ci = 0;
        int cj = 0;
          for(Enumeration e = nodes.elements(); e.hasMoreElements();) {           
            Point2D pt1 = (Point2D) e.nextElement();
            cj =  0;
            for(Enumeration j = nodes.elements(); j.hasMoreElements();) {           
            Point2D pt2 = (Point2D) j.nextElement();            
            if (cj >  ci)
            if (edges[ci][cj] == true)
            {
                g.drawLine( (int) pt1.getX(), (int)pt1.getY(), (int)pt2.getX(), (int)pt2.getY());
            }                         
                cj++;
            }
          ci++;
          }
        }        
    }
    
    public Vector getCloseRect(int x, int y, int radius)
     // this function find the rectangles whose center lays within in the circle center and x,y
    // return a vector of points
     {
         Vector result = new Vector();
         Point2D orig = new Point2D.Double(x,y);
         Point2D ob;
         int ObstacleSectors = 6;
         Point2D ObstacleSec[] = new Point2D[ObstacleSectors];
         
         for(int i = 0; i < ObstacleSectors; i++)
         {ObstacleSec[i]= null;}
         
            for(Enumeration e = rects.elements(); e.hasMoreElements();) {
            Rectangle2D rect = (Rectangle2D) e.nextElement();       
            
                
                //ob = new Point2D.Double(rect.getCenterX(), rect.getCenterY());
            double obsx = 0; 
            double obsy = 0;
            if (x > rect.getX() + rect.getWidth()) obsx = rect.getX() + rect.getWidth();            
            else if (x < rect.getX()) obsx = rect.getX();
            else obsx = x;
            if (y > rect.getY() + rect.getHeight()) obsy = rect.getY() + rect.getHeight();
            else if (y < rect.getY()) obsy = rect.getY();
            else obsy = y;
            

            double angle = Math.atan2(obsy - (double) y , obsx - (double) x ) + Math.PI;  // correct angle to 0-2pi range
            int ksector = (int) Math.floor((angle / (Math.PI * 2)) * ObstacleSectors ); // get a sector number
            //System.out.println(angle + ", "+ ksector);
            if (ksector >= ObstacleSectors) ksector = ObstacleSectors - 1;
            
            //ob = new Point2D.Double(rect.getX() + rect.getWidth() / 2, rect.getCenterY() + rect.getHeight() / 2);
            ob = new Point2D.Double(obsx, obsy);
            if (orig.distance(ob) < radius)
            if (ObstacleSec[ksector] == null)
            {
                ObstacleSec[ksector] = ob;
            }
            else if (ob.distance(x,y) < ObstacleSec[ksector].distance(x,y))
            {
                ObstacleSec[ksector] = ob;
            }
            
            /*if (ObstacleSec[ksector] != Integer.MAX_VALUE && ob.distance(x,y) < ((Point2D) result.get(ObstacleSec[ksector])).distance(x,y) ) 
            {            
                if (orig.distance(ob) < radius) 
                {
                    //result.remove(ObstacleSec[ksector]);
                    result.set(ObstacleSec[ksector], ob ); // update new vector
                    result.add(ob);
                }
            }
            else
            {
                    if (orig.distance(ob) < radius) result.add(ob);
                
            }
             */
                
               
            }
            for(int i = 0; i < ObstacleSectors; i++)
         {if (ObstacleSec[i] != null)result.add(ObstacleSec[i]);
            }
         return result;
     }
    
    
    public boolean checkcontains(double x, double y)
    {
        //Poin2D pt = new Point2D.Double(p.getX(), p.getY()) ;
        
          for(Enumeration e = rects.elements(); e.hasMoreElements();) {
            Rectangle2D rect = (Rectangle2D) e.nextElement();
            if (rect.contains(x, y)) return true;
        }
        return false;
        
    }
    
    public boolean checkintersectsLine(double x1, double y1, double x2, double y2)
    {
        for(Enumeration e = rects.elements(); e.hasMoreElements();) {
            Rectangle2D rect = (Rectangle2D) e.nextElement();            
            if (rect.intersectsLine(x1, y1, x2, y2)) return true;
        }
        return false;
    }
    
    public boolean checkintersectsLineWithBlur(Point2D p1, Point2D p2)
    {
        double x1 = p1.getX();
        double y1 =  p1.getY();
        double x2 =  p2.getX();
        double y2 =  p2.getY();
        
        /*for(Enumeration e = rects.elements(); e.hasMoreElements();) {
            Rectangle2D rect = (Rectangle2D) e.nextElement();
            
            if (rect.intersectsLine(x1, y1, x2,y2)) return true;
        }
       */
        
        return checkintersectsLineWithBlur(x1, y1, x2, y2);        
    }
    
    public boolean checkintersectsLineWithBlur(double x1, double y1, double x2, double y2)
    {
        for(Enumeration e = rects.elements(); e.hasMoreElements();) {
            Rectangle2D rect = (Rectangle2D) e.nextElement();
            if (blurfactor != 0) rect = new Rectangle2D.Double(rect.getX() - blurfactor / 2, rect.getY() - blurfactor / 2, rect.getWidth()+ blurfactor , rect.getHeight() + blurfactor  );
            if (rect.intersectsLine(x1, y1, x2, y2)) return true;
        }
        return false;
    }
    
    public boolean checkintersectsLineWithBlur(double x1, double y1, double x2, double y2, int blurf)
    {
        for(Enumeration e = rects.elements(); e.hasMoreElements();) {
            Rectangle2D rect = (Rectangle2D) e.nextElement();
            if (blurfactor != 0) rect = new Rectangle2D.Double(rect.getX() - blurf / 2, rect.getY() - blurf / 2, rect.getWidth()+ blurf , rect.getHeight() + blurf  );
            if (rect.intersectsLine(x1, y1, x2, y2)) return true;
        }
        return false;
    }
    
    public boolean checkcontainsWithBlur(double x, double y)
    {
        //Poin2D pt = new Point2D.Double(p.getX(), p.getY()) ;
        
          for(Enumeration e = rects.elements(); e.hasMoreElements();) {
            Rectangle2D rect = (Rectangle2D) e.nextElement();
            if (blurfactor != 0) rect = new Rectangle2D.Double(rect.getX() - blurfactor / 2, rect.getY() - blurfactor / 2, (rect.getWidth() + blurfactor ), (rect.getHeight() + blurfactor) );
            if (rect.contains(x, y)) return true;
        }
        return false;
        
    }
    
    public void generateRoadMap(int numnodes, int rangex, int rangey)
    {
     graph = new MyGraph(generateRoadmapNodes(numnodes,rangex, rangey),generateRoadmapEdges());
     calculatePath(0);
    }
    
    public void calculatePath(int sourcenode)
    {
        graph.Dijkstra(sourcenode);
    }
    
     public int findClosestNodeInSight(double x, double y)
     // return the intext to the point that is closest to the point and has a clear path
    {
        Point2D pt = new Point2D.Double(x,y);
        int counter = 0;
        int min = -1;
        int mindist = Integer.MAX_VALUE;
            for(Enumeration e = nodes.elements(); e.hasMoreElements();) {
                Point2D existingnode= (Point2D) e.nextElement();
                int newdist = (int) pt.distance(existingnode);
                
                if (!checkintersectsLine(x,y, existingnode.getX(), existingnode.getY())) // if the path is clear
                if (newdist < mindist) 
                {
                    mindist = newdist;
                    min = counter;
                }
                
                
                counter++;
            }
        
        return min;       
    }
     
    public int findClosestNode(double x, double y)
     // return the intext to the point that is closest to the point and has a clear path
    {
        Point2D pt = new Point2D.Double(x,y);
        int counter = 0;
        int min = -1;
       int mindist = Integer.MAX_VALUE;
       
            for(Enumeration e = nodes.elements(); e.hasMoreElements();) {
                Point2D existingnode= (Point2D) e.nextElement();
                int newdist = (int)  pt.distance(existingnode);
                
                
                if (newdist < mindist) 
                {
                    mindist = newdist;
                    min = counter;
                }
                
                
                counter++;
            }
        
        return min;       
    }
     
     public double getNodeX(int node)
     {return ((Point2D) nodes.get(node)).getX(); }
     
     public double getNodeY(int node)
     {return ((Point2D) nodes.get(node)).getY(); }
     
     public int getNextNode(int node)
     { 
         return graph.pred[node];
     }
    
     public int getNextNode(double x, double y)
     {
                 Point2D pt = new Point2D.Double(x,y);
        int counter = 0;
        int min = -1;
        int mindist = Integer.MAX_VALUE;
            for(Enumeration e = nodes.elements(); e.hasMoreElements();) {
                Point2D existingnode= (Point2D) e.nextElement();
                int newdist = (int) (pt.distance(existingnode) + graph.getDistance(counter));
                
                
                if ((newdist < mindist)  && (!checkintersectsLine(x,y, existingnode.getX(), existingnode.getY())) )
                {
                    mindist = newdist;
                    min = counter;
                }
                
                
                counter++;
            }
        
        return min;       

     }
     
     

    
    public Vector generateRoadmapNodes(int numnodes, int rangex, int rangey)
    {
        for(int i = 0; i < numnodes; i++)
        {
            double x = (Math.random() * rangex);
            double y = (Math.random() * rangey);
            int counter = 0;
            while( (checkcontainsWithBlur(x,y) || checkdistance(x,y, MinDistance )) && counter < 2000 )
            {
                x = (Math.random() * rangex);
                y = (Math.random() * rangey);
                counter++;
            }
            
            if (counter >= 2000) return nodes; //taking too long to find new location 
            
            nodes.add(new Point2D.Double(x,y));
        }
        return nodes;
    }
    
    public boolean[][] generateRoadmapEdges()    
    {
        allocatesEdgeArray(nodes.size(), nodes.size());
        
        int ci = 0;
        int cj = 0;
          for(Enumeration e = nodes.elements(); e.hasMoreElements();) {           
            Point2D pt1 = (Point2D) e.nextElement();
            cj =  0;
            int sectors[] = new int[NumberOfSector];  // allocate an array to keep track if an edges exist in particular sector
            for (int i = 0; i < NumberOfSector; i++)
                sectors[i] = -1; // stored the node number with shortest distance is that particular sector
            
            for(Enumeration j = nodes.elements(); j.hasMoreElements();) {
                Point2D pt2 = (Point2D) j.nextElement();
                double angle = Math.atan2(pt2.getY() - pt1.getY() , pt2.getX() - pt1.getX() ) + Math.PI;  // correct angle to 0-2pi range
                int ksector = (int) Math.floor((angle / (Math.PI * 2)) * NumberOfSector ); // get a sector number
                
                
                if ((pt1 != pt2))
                    //if ( (pt1.distance(pt2) < MaxPathDistance) && !checkintersectsLineWithBlur(pt1, pt2))
                    if (!checkintersectsLineWithBlur(pt1, pt2)) {
                        if (sectors[ksector] == -1) {
                            edges[ci][cj] = true;  // no edges in the particualr sector yet
                            edges[cj][ci] = true;  // no edges in the particualr sector yet
                            sectors[ksector] = cj;
                        }
                        else {
                            Point2D pt3 = (Point2D) nodes.get(sectors[ksector]);
                            
                            if (pt1.distance(pt2) < pt1.distance(pt3)) {
                                
                                edges[ci][cj] = true;  // set new edge to true
                                edges[ci][sectors[ksector]] = false;  // set previous edge to false
                                edges[ sectors[ksector]][ci] = false;  // set previous edge to false
                                sectors[ksector] = cj;
                            }
                          
                        }
                        
                        
                        
                    }
                
                cj++;
            }
            ci++;
          }

        return edges;
    }
    
    public boolean[][] allocatesEdgeArray(int maxx, int maxy) {
        /// allocating space for the new array, and fill with false (no link)
         edges = new boolean[maxx][];
        for(int i = 0; i< maxx; i++) {
            edges[i] = new boolean[maxy];
        }
        for(int i = 0; i < maxx; i++)
            for (int j =0; j<maxy; j++)
                edges[i][j] = false;
        
         return edges;
    }
    
    public boolean checkdistance(double x, double y, int mindist)
    // make sure new points is not too close to any existing points
    {
         for(Enumeration e = nodes.elements(); e.hasMoreElements();) {
             
            Point2D pt = (Point2D) e.nextElement();
            if ( pt.distance(x, y) < mindist) return true;
        }
         return false;
    }
    
    public void clearRoadMap()
    {
        nodes.clear();
        edges = null;
    }
    
   /************* private helper functions*/
   private String[] ExtractParameter(String par)
    /* this function breaks down parameter string into numpar strings and put in a vector
     *
     * return null if number of parameter doesnt match detected
     */    
    {
        String[] result = null;
        result = par.substring(1, par.length()-1).trim().split("\\s*,\\s*");     
        return result;
    }
   
     public static void main(String[] args) throws IOException {
         new RectBackground();
     }
     
    

    
            
}
