/*
 * TorusLine.java
 *
 * Created on February 14, 2004, 2:47 PM
 */

package MySimulation;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Component;
import javax.swing.JPanel;
import java.awt.Dimension;



/**
 *
 * @author  Kevin Chiou
 */
public class TorusLine {
    int x1,x2,y1,y2;
    boolean wrapped = false;
    Color col = Color.black;
    //JPanel background = null;
    int maxx = 0;
    int maxy = 0;
    int flash = 0;
    boolean debug = false;
    /** Creates a new instance of TorusLine */
    /*
    public TorusLine() {
        x1 = x2 = y1= y2 = 0;
        wrapped = false;
    }
    
    public TorusLine(int ix1, int iy1, int ix2, int iy2, boolean wrap ) {
        x1 = ix1;
        x2 = ix2;
        y1 = iy1;
        y2 = iy2;
        
        wrapped = wrap;
    }
    
    public TorusLine(int ix1, int iy1, int ix2, int iy2, boolean wrap, Color icolor ) {
        x1 = ix1;
        x2 = ix2;
        y1 = iy1;
        y2 = iy2;
        
        wrapped = wrap;
        col = icolor;
    }
    
     public TorusLine(int ix1, int iy1, int ix2, int iy2, boolean wrap, Color icolor, JPanel bk ) {
         
        x1 = ix1;
        x2 = ix2;
        y1 = iy1;
        y2 = iy2;
        
        wrapped = wrap;
        col = icolor;
     setDim(bk);
    }
    
     */
    public void setDim(JPanel bk)
    {
        Dimension r = bk.getSize();
        maxx = (int) r.getWidth();
        maxy = (int) r.getHeight();
    
    }
    
    public TorusLine(int ix1, int iy1, int ix2, int iy2, boolean wrap, Color icolor, Dimension r) {
         
        int temp;
        x1 = ix1;
        x2 = ix2;
        if (x1 > x2)
        {
            temp = x1;
            x1 = x2;
            x2 = temp;
        }
        
        
        y1 = iy1;
        y2 = iy2;
        
        if (y1 > y2)
        {
            temp =y1;
            y1 = y2;
            y2 = temp;
        }
        
        
        wrapped = wrap;
        col = icolor;
     setDim(r);
    }
    
     public void setDim(Dimension r)
    {
        
        maxx = (int) r.getWidth();
        maxy = (int) r.getHeight();
    
    }
     
   public void setFlash(int i)
   {flash = i;}
    
    public void paint(Graphics g)
    {
        if (flash > 0) 
        {
            paintRandom(g);
            flash--;
            return;
            
        }
        
        Color org = g.getColor();
        g.setColor(col);
        
        if (debug)g.drawOval(x1 -10, y1-10, 20,20);
        if (debug)g.drawOval(x2-5, y2-5, 10,10);
            
        //if (x1 == x2 && y1 == y2) throw new RuntimeException("bad Torus line: same start and end");
        if (wrapped)
        {
            if (x1 == x2)
            {
                g.drawLine(x1, 0, x1, y1) ;
                g.drawLine(x2, y2, x2, maxy) ;
                //System.out.println("same x" + y2 + "," + y1 + ";");
                
            }
            else if (y1 == y2)
            {
                g.drawLine(0, y1, x1, y1) ;
                g.drawLine(x2, y2, maxx, y2) ;
                //System.out.println("same y");
                //System.out.println("same y" + x2 + "," + x1 + ";");
                
            
            }
            else {throw new RuntimeException("invalid Torus line"); }
        }
        else
        {
            g.drawLine(x1, y1, x2, y2) ;
        }
        g.setColor(org);
    }
    
     public void paintRandom(Graphics g)
    {
         Color org = g.getColor();
        g.setColor(randColor());
        
        if (debug)g.drawOval(x1 -10, y1-10, 20,20);
        if (debug)g.drawOval(x2-5, y2-5, 10,10);
            
        if (x1 == x2 && y1 == y2) throw new RuntimeException("bad Torus line: same start and end");
        if (wrapped)
        {
            if (x1 == x2)
            {
                g.drawLine(x1, 0, x1, y1) ;
                g.drawLine(x2, y2, x2, maxy) ;
                //System.out.println("same x" + y2 + "," + y1 + ";");
                
            }
            else if (y1 == y2)
            {
                g.drawLine(0, y1, x1, y1) ;
                g.drawLine(x2, y2, maxx, y2) ;
                //System.out.println("same y");
                //System.out.println("same y" + x2 + "," + x1 + ";");
                
            
            }
            else {throw new RuntimeException("invalid Torus line"); }
        }
        else
        {
            g.drawLine(x1, y1, x2, y2) ;
        }
        g.setColor(org);
    }
     
     public Color randColor()
    {return new Color((int) (Math.random() * 255),(int) (Math.random() * 255),(int) (Math.random() * 255));}
    
}

